(***********************************************************************)
(*                                                                     *)
(*                           Objective Caml                            *)
(*                                                                     *)
(*               Pierre Weis, projet Cristal, INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 2001 Institut National de Recherche en Informatique et   *)
(*  en Automatique.  All rights reserved.  This file is distributed    *)
(*  only by permission.                                                *)
(*                                                                     *)
(***********************************************************************)

(* $Id: explode.mli,v 1.4 2008/08/26 16:19:30 weis Exp $ *)

(** This is the interface of the [Explode] module.

This file lists the values offered by the module with their respective types.

The implementation file must define the same set of values with the
corresponding types. Otherwise, the compiler will complain and abort the
compilation of the module.

Fancy [(** blabla *)] comments are documentation annotations written in the
syntax of the [ocamldoc] tool.

Ocamldoc automatically extracts the documentation from annotated Caml source
files and outputs files in various formats (including TeX or ASCII texts)
including a set of hyper text files.

*)

val explode : string -> char list
(** [explode s] returns the list of characters of string [s]. *)
;;

val implode : char list -> string
(** [implode chars] returns the string that has [chars] as list of characters.
    [implode] is the converse function of [implode]:
    [implode (explode s)] is equal to [s], and [explode (implode chars)]
    is equal to [chars]. *)
;;
