(***********************************************************************)
(*                                                                     *)
(*                           Objective Caml                            *)
(*                                                                     *)
(*               Pierre Weis, projet Cristal, INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 2007 Institut National de Recherche en Informatique et   *)
(*  en Automatique.  All rights reserved.  This file is distributed    *)
(*  only by permission.                                                *)
(*                                                                     *)
(***********************************************************************)

(* $Id: module_backbone_link.ml,v 1.2 2009/11/14 12:04:03 weis Exp $ *)

module Make (AInfo : Module_types.INFO) = struct

  include Module_chemical_group.Make (AInfo);;

  module Backbone_link = struct

    type backbone_link = {
      n : Aggregate.site;
      p : Path.path;
    }
    ;;

    let make site path = {
      n = Chemical_group.double_site site;
      p = path;
     }
    ;;

  end
  ;;

end
;;
