(***********************************************************************)
(*                                                                     *)
(*                        SciCos compiler                              *)
(*                                                                     *)
(*            Pierre Weis                                              *)
(*                                                                     *)
(*                               INRIA Rocquencourt                    *)
(*                                                                     *)
(*  Copyright 2009 INRIA                                               *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: treat.ml,v 1.4 2009/11/16 00:43:22 weis Exp $ *)

let parse lexbuf =
  Parser.file Lexer.token lexbuf
;;

let parse_file fname =
  let ic = open_in fname in
  let lexbuf = Lexing.from_channel ic in
  let ast = parse lexbuf in
  close_in ic;
  ast
;;

let parse_string s =
  let lexbuf = Lexing.from_string s in
  parse lexbuf
;;

let treat_ast ast =
  Scoping.scope ast;
  let ppf = Format.std_formatter in
  Format.fprintf ppf "%a@." Print_ast.print ast
;;

let treat_file fname =
  treat_ast (parse_file fname)
;;

let treat_string s =
  treat_ast (parse_string s)
;;
